<?php

declare(strict_types=1);

namespace Quivers\Integration\Setup\Patch\Data;

use Magento\Framework\Setup\ModuleDataSetupInterface;
use Magento\Framework\Setup\Patch\DataPatchInterface;

use Magento\Eav\Model\Entity\Attribute\ScopedAttributeInterface;
use Magento\Eav\Setup\EavSetup;
use Magento\Eav\Setup\EavSetupFactory;

use Magento\Customer\Model\Customer;
use Magento\Customer\Setup\CustomerSetupFactory;
use Magento\Framework\App\ResourceConnection;
use Magento\Framework\Setup\Patch\PatchVersionInterface;

use Magento\Sales\Model\Order\StatusFactory;
use Magento\Sales\Model\ResourceModel\Order\StatusFactory as StatusResourceFactory;

use Magento\Sales\Model\ResourceModel\Order\Status\CollectionFactory;

use Magento\Framework\Setup\ModuleContextInterface;
/**
* Patch is mechanism, that allows to do atomic upgrade data changes
*/
class DataOrderStatuses implements DataPatchInterface
{	
	
	protected $statusFactory;
    protected $statusResourceFactory;
	protected $orderStatusCollectionFactory;

    /**
     * @var ModuleDataSetupInterface $moduleDataSetup
     */
    private $moduleDataSetup;

	/**
     * EavSetupFactory
     *
     * @var EavSetupFactory
     */
	private $eavSetupFactory;

    private $customerSetupFactory;

    /**
     * @param ModuleDataSetupInterface $moduleDataSetup
     */
	    /**
     *
     * @param EavSetupFactory          $eavSetupFactory
     */
    public function __construct(ModuleDataSetupInterface $moduleDataSetup,CustomerSetupFactory $customerSetupFactory,EavSetupFactory $eavSetupFactory,\Magento\Eav\Api\AttributeRepositoryInterface $attributeRepository,StatusFactory $statusFactory,StatusResourceFactory $statusResourceFactory,CollectionFactory $orderStatusCollectionFactory)
    {
        $this->moduleDataSetup = $moduleDataSetup;
        $this->customerSetupFactory = $customerSetupFactory;
		$this->eavSetupFactory = $eavSetupFactory;
		$this->attributeRepository = $attributeRepository;
		$this->statusFactory = $statusFactory;
        $this->statusResourceFactory = $statusResourceFactory;
		$this->orderStatusCollectionFactory = $orderStatusCollectionFactory;
    }

    /**
     * Do Upgrade
     *
     * @return void
     */
    public function apply()
    {   	
		foreach($this->orderStatusCollectionFactory->create()->toOptionArray() as $x => $val) {
			if(!array_search ('in_progress', $val)){
				$custom_status_code = 'in_progress';
				$custom_state_code = 'in_progress';
				$custom_status_label = 'In Progress';
				$statusResource = $this->statusResourceFactory->create();
				$status = $this->statusFactory->create();
				$status->setData([
					'status' => $custom_status_code,
					'label' => $custom_status_label,
				]);
			
				$statusResource->save($status);
				$status->assignState($custom_state_code, true, true);
			}
			if(!array_search ('holded', $val)){
				$custom_status_code = 'holded';
				$custom_state_code = 'holded';
				$custom_status_label = 'On Hold';
				$statusResource = $this->statusResourceFactory->create();
				$status = $this->statusFactory->create();
				$status->setData([
					'status' => $custom_status_code,
					'label' => $custom_status_label,
				]);
			
					$statusResource->save($status);
				$status->assignState($custom_state_code, true, true);
			}
		  }
    }

    /**
     * @inheritdoc
     */
    public function getAliases()
    {
        return [];
    }

    /**
     * @inheritdoc
     */
    public static function getDependencies()
    {
        return [
          //  UpdateIdentifierCustomerAttributesVisibility::class,
        ];
    }
	public static function getVersion()
	{
  		return '2.3.6';
	}
}